% Program UC-DP
% Optimln sestava jednotek -Unit Commitment - metoda Dynamickho Programovn
% Pklad
A0=[500;400;600;400];A1=[8.0;6.4;7.9;7.5];A2=[0.004;0.0048;0.0050;0.0055];
B0=A1; B1=2*A2;   % parametry charakteristiky pomrnch prstk
Pmin=[100;100;75;75];Pmax=[625;625;600;500];% meze vkonu
Cup=[3000;3000;3000;3000];Cdwn=[1500;1500;1500;1500];% cena najet a odstaven
PL=[1100;1400;1600;1800;1400;1100]; %diagram zte
TD=[4;4;4;4;4;4];%dlka trvn intervalu
Sgr=[1 1 1 1;
     1 1 1 1;
     1 1 0 0;
     1 0 1 0];     % nastaven spina grupy
Nt=size(PL,1);Ngr=size(Sgr,2);Ngen=size(A0,1);  %Dimenze pol
% grupa oznauje sestavu agregt, je uloena ve sloupci Sgr jako kombinace 0,1
% slo adku je slo stroje, slo sloupce je slo grupy
Jopt=zeros(Nt,Ngr);Uopt=zeros(Nt,Ngr); %pole optimlnch hodnot kriteria optimlnch rozhodnut
Cig=zeros(Nt,Ngr,Ngen);Pig=zeros(Nt,Ngr,Ngen);%pole vkon a cen
Grzac=4;Grkon=4; %definice zatench a koncovch grup.Lze je zskat metodou vypnn                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    

% Ekonomick rozdlen
for gr = 1:Ngr,               % cyklus pes sla grup (=sloupce Sgr)	
B1gr(gr)=1/sum(Sgr(:,gr) ./B1);% ekvivalentn parametry grupy
B0gr(gr)=B1gr(gr)*sum((Sgr(:,gr) .*B0) ./B1);
     for t=1:Nt,    % cyklus pes t-intervaly P-diagramu
        b(t,gr)=B1gr(gr)*PL(t)+B0gr(gr); %pom. prstky 
         suma=0;
			for g=1:Ngen        
Pig(t,gr,g)=Sgr(g,gr)*(b(t,gr)-B0(g))/B1(g);% vkon jednotlivch stroj   
Cig(t,gr,g)=Sgr(g,gr)*A0(g)+(A1(g) + A2(g)*Pig(t,gr,g))*Pig(t,gr,g);	% cena prce stroj             
  			suma=suma + Cig(t,gr,g);
        end %g
        Ctgr(t,gr)=suma*TD(t);
		end %t
   end %gr
   
   
   
   
   %ceny pechodu
   Tij=zeros(Ngr,Ngr);
   for i=1:Ngr
      for j=1:Ngr
         suma=0;
		   for g=1:Ngen,
suma=suma+Cup(g)*(Sgr(g,j)-Sgr(g,i))*Sgr(g,j)+Cdwn(g)*(Sgr(g,i)-Sgr(g,j)*Sgr(g,i));
			end %g
		Tij(i,j)=suma;
		end% j
	end %i
    
% fze podmnn optimalizace
t=Nt;
Uopt(t,:)=Grkon; j=Grkon;
for  i=1:Ngr,  
    Jopt(t,i)=Ctgr(t,i)+Tij(i,j);
end %i   
  
for t=Nt-1:-1:2
	for i = 1:Ngr,  
		Minimum=realmax;
   for j = 1:Ngr,
     cena= Ctgr(t,i)+Tij(i,j)+Jopt(t+1,j);
 			if cena < Minimum 
			   Jopt(t,i)=cena;
   			Uopt(t,i)=j;
   			Minimum=cena;
			end%if
   end % j
 end %i
end % t

%prvn interval
Minimum=realmax;
for j = 1:Ngr,
   cena=Ctgr(1,Grzac)+Tij(Grzac,j)+Jopt(2,j);
   		if cena < Minimum 
			   Jopt(1,Grzac)=cena;
   			Uopt(1,Grzac)=j;
   			Minimum=cena;
			end%if
   end % j
 
   % nepodmnn optimalizace
   Str(1)=Grzac;Str(Nt)=Grkon;%vynucen strategie
     for t=2:Nt-1,
	Str(t)=Uopt(t-1,Str(t-1));		
	  end %t